#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>
#include <wiringPi.h>
#include "arduino.h"
#include "io.h"
#include "request.h"
 
int main() {
	int sockfd;
	int client_sockfd;
	struct sockaddr_in addr;

	socklen_t len = sizeof( struct sockaddr_in );
	struct sockaddr_in from_addr;
 
	char buf[1024];
 
	// 受信バッファ初期化
	memset( buf, 0, sizeof( buf ) );
 
	//arduino,ioをopenにする
	if(arduino_open() != 0) return -1;
	if(io_open() != 0) return -1;
 
	// ソケット生成
	if( ( sockfd = socket( AF_INET, SOCK_STREAM, 0 ) ) < 0 ) {
		perror( "socket" );
	}
 
	// 待ち受け用IP・ポート番号設定
	addr.sin_family = AF_INET;
	addr.sin_port = htons( 51000 );
	// ローカルホストを指定
	//addr.sin_addr.s_addr = inet_addr( "172.21.3.136" );
	addr.sin_addr.s_addr = INADDR_ANY;
 
	// バインド
	if( bind( sockfd, (struct sockaddr *)&addr, sizeof( addr ) ) < 0 ) {
		perror( "bind" );
	}
 
	// 受信待ち
	if( listen( sockfd, SOMAXCONN ) < 0 ) {
		perror( "listen" );
	}
 
	// クライアントからのコネクト要求待ち
	if( ( client_sockfd = accept( sockfd, (struct sockaddr *)&from_addr, &len ) ) < 0 ) {
		perror( "accept" );
	}
 
	// 受信
	int rsize;
	while( 1 ) {

		rsize = recv( client_sockfd, buf, sizeof( buf ), 0 );
		//printf( "rsize = %d\n", rsize );

		if ( rsize > 0 ) {
			//受信されたときの動作
				printf( "receive: %s\n", buf );
			
				while(1){
					sleep(3);
					
					printf("Hello World!\n");
				
					io_led(1);
					usleep(3000*1000);
				
				
				

					request_set_runmode(STR, 50, 172); 
					usleep(3440*1000);
				
					for(int i = 0;i < 2;i++){				
						request_set_runmode(ROT, 35, -45); 
						usleep(448*1000);
						request_set_runmode(STR, 50, 40);
						usleep(800*1000);
						request_set_runmode(ROT, 35, -45); 
						usleep(448*1000);
						request_set_runmode(STR, 50, 29);
						usleep(580*1000);
						request_set_runmode(ROT, 35, -45); 
						usleep(448*1000);
						request_set_runmode(STR, 50, 40);
						usleep(800*1000);
						request_set_runmode(ROT, 35, -45); 
						usleep(448*1000);
				

						request_set_runmode(STR, 50, 132); 
						usleep(3440*1000);
					
						request_set_runmode(ROT, 35, 45); 
						usleep(448*1000);
						request_set_runmode(STR, 50, 40);
						usleep(800*1000);
						request_set_runmode(ROT, 35, 45); 
						usleep(448*1000);
						request_set_runmode(STR, 50, 29);
						usleep(580*1000);
						request_set_runmode(ROT, 35, 45); 
						usleep(448*1000);
						request_set_runmode(STR, 50, 40);
						usleep(800*1000);
						request_set_runmode(ROT, 35, 45); 
						usleep(448*1000);
					
						request_set_runmode(STR, 50, 132); 
						usleep(3440*1000);
					}
				
					request_set_runmode(ROT, 35, 45); 
					usleep(448*1000);
					request_set_runmode(STR, 50, 40);
					usleep(800*1000);
					request_set_runmode(ROT, 35, 45); 
					usleep(448*1000);
				
					request_set_runmode(STR, 50, 104);
					usleep(2080*1000);
				
					request_set_runmode(ROT, 35, 45); 
					usleep(448*1000);
					request_set_runmode(STR, 50, 40);
					usleep(800*1000);
					request_set_runmode(ROT, 35, 45); 
					usleep(448*1000);
				
					request_set_runmode(STR, 50, 172);
					usleep(3440*1000);
				
					request_set_runmode(ROT, 35, 90); 
					usleep(896*1000);
				
					io_led(0);
			
					break;
				}


				printf("Finish!\n");
		
			
			
			
			
			
		} else if ( rsize == 0) {
		break;
	}
	}
 
	//ardduinoクローズ
	arduino_close();
 
	// ソケットクローズ
	close( client_sockfd );
	close( sockfd );
 
 
	return 0;
}
